{-# LANGUAGE DerivingVia #-}
{-# LANGUAGE DeriveGeneric #-}
module Language.Java.Classfile (Classfile(..)) where
import Language.Java.Classfile.Version (Version)
import Language.Java.Classfile.Magic (Magic)
import GHC.Generics (Generic, Generically(Generically))
import Language.Java.Classfile.Extractable (Extractable)
import Language.Java.Classfile.ConstantPool (ConstantPool)
import Language.Java.Classfile.Flags (Flags)
import Language.Java.Classfile.ClassFlag (ClassFlag)
import Language.Java.Classfile.ConstantPool.References (ClassReference)
import Language.Java.Classfile.Interfaces (Interfaces)

data Classfile = Classfile
  { magic        :: Magic
  , version      :: Version
  , constantPool :: ConstantPool
  , accessFlags  :: Flags ClassFlag
  , this         :: ClassReference
  , super        :: ClassReference
  , interfaces   :: Interfaces
  }
  deriving stock (Show, Generic)
  deriving Extractable via Generically Classfile
