{-# LANGUAGE InstanceSigs #-}
{-# LANGUAGE TypeApplications #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE UndecidableInstances #-}
module Language.Java.Classfile.Flags (Flags(..)) where

import Data.Set (Set)
import Language.Java.Classfile.Extractable (Extractable (extract))
import Language.Java.Classfile.Extract (Extract)
import Language.Java.Classfile.Flag (FlagMask(..))
import Data.Enum.Util (enumerate)
import qualified Data.Set as Set
import Data.Bits (Bits((.&.)))

newtype Flags a = Flags (Set a)
  deriving (Show)

instance (Extractable (FlagType a), Bounded a, Enum a, Ord a, FlagMask a, Bits (FlagType a), Num (FlagType a)) => Extractable (Flags a) where
  extract :: Extract (Flags a)
  extract = do
    flags <- extract @(FlagType a)
    let allFlags = enumerate @a
    let isContained flag = (maskOf flag .&. flags) /= 0

    pure . Flags . Set.fromList $ filter isContained allFlags

